#include<iostream>
#include<cstdio>
#include<map>
#include<vector>
#include<queue>
#include<stack>
#include<cmath>
#include<algorithm>

#define REP(i,n) for(int i=0; i<n; i++)

typedef long long ll;
using namespace std;

ll nwd(ll a, ll b) { if(b==0) return a; return nwd(b, a%b);}
ll nww(ll a, ll b) { return (a/nwd(a,b))*b; }

void nwd(ll a, ll b, ll &d, ll &x, ll &y){
	//cerr << a << " : "<<b<<endl; 
	if(b==0) {d=a; x=1; y=0; return; }
	nwd(b, a%b, d, x, y);
	ll tmp=y;
	y=x-(a/b)*y;
	x=tmp;
}

ll solve_linear_equation(ll a, ll b, ll n)
{
	ll d, x, y, x0, res;
	nwd(a,n,d,x,y);
	if(b%d!=0) return -1;
	x0=((x*(b/d))%n+n)%n;
	res=x0;
	REP(i,d) { 
		res = min( res, (x0+i*(n/d))%n );
	}
	return res;
}

struct card
{
	ll first;
	ll cycle;
};

card merge(card a, card b) 
{
	card ret;
	ll sss= solve_linear_equation(a.cycle,-a.first + b.first,b.cycle);
	if(sss == -1) {
		ret.first = -1;
		ret.cycle = -1;
		return ret;
	}
	ret.first =a.cycle * sss  + a.first; 
	ret.cycle = nww(b.cycle, a.cycle);
	return ret;
}

int n;

card tab[6][5005];

ll next(ll i)
{
	ll res;
	switch((i-1)/n)
	{
		case 0: case 1: res=5*((i-1)/2)-i%2+2;
		//cerr<<"1"<<endl;		
 		break;
		case 2: case 3: res=5*((i-1-2*n)/2)-i%2+4;
		//cerr<<"2"<<endl;
		break;
		case 4: res=5*(i-1-4*n)+5; 
		//cerr<<"3"<<endl;
		break;
	}
	//cerr<<"Next of "<<i<<" is "<<res<<endl;
	return res;
}

void process(ll num,ll i)
{
	if(num>5)
		return;
	REP(j,5*n+1)
	{
		tab[num][j].first=0;
		tab[num][j].cycle=0;
	}
	tab[num][i].first=1;
	ll k=2;
	i=next(i);
	while(tab[num][i].first==0)
	{
		tab[num][i].first=k++;
		i=next(i);
	}
	ll len=k-1;
	while(tab[num][i].cycle==0)
	{
		tab[num][i].cycle=len;
		//cerr<<"num: "<<num<<" pos: "<<next(i)<<" first: "<<tab[num][i].first<<" cycle: "<<tab[num][i].cycle<<endl;
		i=next(i);
	}
	
}

void go() {
	REP(i, 5*n) {
		ll temp;
		cin >> temp;
		process(temp, i+1);
	}
	ll best = -1;
	ll player = -1;
	REP(i,n) {
		int perm[] = {1,2,3,4,5};
		do
		{
			card a[5];
			a[0] = tab[perm[0]][2*i+1];
			a[1] = tab[perm[1]][2*i+2];
			a[2] = tab[perm[2]][2*i+2*n+1];
			a[3] = tab[perm[3]][2*i+2*n+2];
			a[4] = tab[perm[4]][i+4*n+1];
			bool good = false;
			REP(j,5) {
				if(a[j].first == 0) good = true;
			}
			if(good) continue;

			
			//if(i==0)
			//{
			//	cerr<<"Player "<<i+1<<endl;
			//	REP(j,5)
			//	{
			//		cerr<<"Card "<<perm[j]<<" first "<<a[j].first<<" cycle "<<a[j].cycle<<endl;
			//	}
			//}

			REP(j,4) {
				a[4] = merge(a[4],a[j]);
				//cerr<<" ++ Card "<<perm[j]<<" first "<<a[4].first<<" cycle "<<a[4].cycle<<endl;
				
				if(a[4].first < 0) break;
				
			}
			if(a[4].first < 0) continue;
			if(best == -1 || a[4].first < best) {
				best = a[4].first;
				player=i+1;
			}
		}	
		while(next_permutation(perm, perm+5));
	}
	//cout << best << endl;
	if(best!=-1)
	{
		cout<<"Player "<<player<<" wins game number "<<best<<"."<<endl;
	}
	else
		cout<<"Neverending game."<<endl;
}


int main() {
	int www=12;
	n=5;
	//REP(i,152)
	//{
	//	www=next(www);
	//}
	//cout<<www<<endl;
 
	cin >> n;
	while(n) {
		go();
		cin >> n;
	}
	return 0;
}
